#pragma once
#include "defs.h"
#include "tile.h"

#define CHUNK_WIDTH 3
#define CHUNK_HEIGHT CHUNK_WIDTH
#define CHUNK_DEPTH CHUNK_HEIGHT

/**
 * Loads a given chunk.
 * 
 * @param list List to load the chunk for.
 * @param chunk The chunk to load.
 * @param x X of the chunk.
 * @param y Y of the chunk.
 * @param z Z of the chunk.
 */
void chunkLoad(chunklist_t *list, chunk_t *chunk,
  int32_t x, int32_t y, int32_t z
);

/**
 * Unload a given chunk.
 * 
 * @param list List that the chunk belongs to.
 * @param chunk Chunk to unload.
 */
void chunkUnload(chunklist_t *list, chunk_t *chunk);